/********************************************************/
/*                                                      */
/* LIST.CMD - IBM Object REXX Sample Program            */
/*                                                      */
/* Demonstrate the usage of the Object REXX built-in    */
/* list class.                                          */
/*                                                      */
/* ---------------------------------------------------- */
/* (C) Copyright IBM Corp. 1997 - All Rights Reserved.  */
/*                                                      */
/* DISCLAIMER OF WARRANTIES.  The following [enclosed]  */
/* code is sample code created by IBM Corporation. This */
/* sample code is not part of any standard or IBM       */
/* product and is provided to you solely for the        */
/* purpose of assisting you in the development of your  */
/* applications.  The code is provided "AS IS", without */
/* warranty of any kind.  IBM shall not be liable for   */
/* any damages arising out of your use of the sample    */
/* code,  even if they have been advised of the         */
/* possibility of such damages.                         */
/*                                                      */
/********************************************************/
myList = .List~New
myList~Insert("John") /* add John to the end of the list */
myList~~Insert("Bob")~Insert("Anne")

Say "The list now contains" myList~Items "items."

Index = myList~First /* get index of first element */
Say "The first item in the list is:" myList~At(Index)

Index = myList~Next(Index)    /* get index of second element */
myList~Insert("Peter", Index) /* add Peter after second item */

myList~Insert("David", .nil)  /* insert David at top of list */

Do Name Over myList
  Say Name
End